Copyright: Copyright 1995-96 Dave O'Brien


Contents

Welcome to Smoke'em Poker, a freeware game of five-card draw poker.

Before You Begin

Quick Start!	Introduction

System Requirements	What's New?

Background

About Five-Card Draw	What Beats What?

House Rules	Four-Card Hands

Playing Smoke'em Poker

Setting Options	Starting A New Game

Playing A Hand	Key Shortcuts

Examining The Odds	Generating Statistics

Controlling Sound	Getting Help

Running Out Of Money	Watching The Game

Saving Unfinished Games 	Resuming Saved Games

When The Dealin's Done

Quitting The Program	Uninstalling The Program

Sending Me Feedback

The Fine Print

Known Problems	About BeerWare

Future Enhancements	About The Author

Acknowledgments	About Borland Delphi

Version History	Redistribution (Legal Stuff)


Quick Start!

Smoke'em Poker is a freeware program that simulates a weekend game of five-card draw poker. You play against up to 5 opponents controlled by the computer.

Requirements: Windows 3.1, Windows 95, or Windows NT.

To change the game settings, click Options. Some changes take effect immediately, while others don't apply until you start a new game (by clicking New Game).

Each hand of five-card draw proceeds as follows:

•	ante and dealing

•	opening bets (no minimum hand to open)

•	discarding cards (1 discard of up to 3 cards)

•	closing bets

•	the showdown (where you win, lose, or tie)

All standard poker hands are allowed, including ace-low straights (A-2-3-4-5).

Check-raising (sandbagging) can be prohibited. If a computer player runs out of money, they're out of the game. If you run out of money, you can end the game or Watch the other players continue.

After any hand, you can view statistics and graphs of the current game.

You can save a game at any point, then resume it later.

For more details, see the other topics in this documentation.

For information on what's new in this version, see Version History.

Just Deal It!


Introduction

Welcome to Smoke'em Poker. Ante up and deal it, Tex!

The game is five-card draw. You play against five other simulated players who would like nothing better than to "smoke" you on a big pot.

Smoke'em Poker simulates a casual weekend poker game with your friends. It does not try to recreate a real casino's rules or betting structures (but if you have suggestions, I'd be happy to hear them).

Smoke'em Poker uses a standard Windows user interface. If you've played draw poker before, and have used Windows before, you should have no problem playing Smoke'em Poker.


System Requirements

Smoke'em Poker requires the following to run:

•	386 processor (or better)

•	Microsoft Windows 3.1 (or later), Windows 95, or Windows NT

•	about 2.5 megs of disk space

•	a Windows-compatible sound card (if you want sound)

I'm not sure exactly how much memory you need to run Smoke'em Poker. It works OK on a Win95 PC with 6 megs, but your mileage may vary.


What's New In This Version?

Here's a summary of the major changes in Smoke'em Poker 1.9:

•	added ability to save and load games

•	added options for:

−	redealing if no one opens

−	four-card draw on ace-high hands

−	starting final bets with opener or last raiser

•	added welcome dialog instead of dumping you right into a game

•	changed key shortcuts to allow (mostly) one-handed play

•	improved (and fixed) sound handling, and added new sounds

•	fixed the nasty "black-card" bug that some users encountered

For a complete history of changes, see Version History.


About Five-Card Draw

Poker comes in hundreds of different flavors, but five-card draw is probably the best known and simplest form. Here's how it goes:

•	The first dealer is determined randomly. On each subsequent hand, the deal rotates clockwise around the table.

•	After paying an initial ante, each player is dealt five cards down (visible only to that player).

•	After the cards are dealt, the opening round of betting starts with the player to the left of the dealer. Betting continues clockwise around the table until all players have matched the highest bet or folded out of the hand. There is no minimum hand required to open the betting.

•	All players who paid the opening bet can then discard up to three cards from their hands. These cards are replaced by the same number of new cards from the deck.
Optionally, players with ace-high hands can discard four cards instead of three.

•	A closing round of betting follows. All players who match the final bet then reveal their hands in the "showdown". The player with the best hand wins the "pot" (the accumulated money bet during the hand). In case of a tie (which is rare), the winners split the pot.

For more information on using Smoke'em Poker's interface to play a round of five-card draw, see Playing A Hand.


What Beats What?

For those of you who keep forgetting, here's the order of poker hands (from worst to best):

•	Runt (nothing, nada, e.g. 2-4-7-J-K)

•	Pair (e.g. 2-2-7-J-K)

•	Two Pair (e.g. 2-2-7-7-K)

•	Three of a Kind (e.g. 2-2-2-J-K)

•	Straight (e.g. 2-3-4-5-6, but mixed suits)

•	Flush (e.g. five hearts, but not consecutive)

•	Full House (e.g. 2-2-2-7-7)

•	Four of a Kind (e.g. 2-2-2-2-7)

•	Straight Flush (e.g. 2-3-4-5-6, all of the same suit)

•	Royal Flush (10-J-Q-K-A, all of the same suit)

Smoke'em Poker automatically displays which of these hands you have. It's up to you to make money with it.

(In some cases, Smoke'em Poker may tell you that you have an inside straight, outside straight, "baby" flush, or "baby" straight flush. For more information on these incomplete hands, see Four-Card Hands.)


House Rules

Every poker gathering decides on a few "house rules". Here are the house rules for Smoke'em Poker:

Ace-Low Straights:

Normally, aces are high (valued above kings). The only exception to this is a ace-low straight (A-2-3-4-5), where the ace is the "one" card. If you get an ace-low straight, Smoke'em Poker automatically re-sorts your hand to put the ace before the 2. Note that an ace can only be high or low (not both) in a given hand. You cannot create a "wrap-around" straight using an ace (for example, Q-K-A-2-3 is not a valid straight).

Splitting Pots:

Once in a great while, two or more players will tie at the showdown. For example, two players may have the same two pairs. In this case, the "kickers" (the remaining cards in their hands) determine the winning hand. If the kickers are also equal, the players split the money in the pot equally. In case of tied flushes (for example, two players with king-high flushes), the suit is not used to break the tie - suits have no inherent value.

Check-Raising (Sandbagging):

Check-raising means that if player A checks, then player B raises, player A is allowed to re-raise the bet.

You might check-raise when you have a strong hand but want to see who else does too. Instead of making the first raise, you check (pass) the bet. When someone else raises, you can then can raise them more. If you disallow check-raising, player A (in the example above) would not be allowed to re-raise - they would have to call instead.

To change this setting, see Options - Rules.

Redealing If No One Opens:

Occasionally, during opening bets for a hand, no one will feel like making the first move, and everyone ends up checking (passing).

In this case, according to Hoyle, the ante stays in the pot and the deal moves on to the next dealer. Alternatively, you can simply continue the hand (discarding and final betting).

To change this setting, see Options - Rules.

Four-Card Draw On Ace-High Hands:

Normally, you can draw up to three cards to improve your hand. Optionally, you can also allow players with ace-high runts to keep the ace and discard the other four cards.

In this situation, you can choose to carry on with the hand, or you can keep the ante in the pot and move on to the next hand.

To change this setting, see Options - Rules.

Start Final Bets At Opener Or Last Raiser:

According to Hoyle, the final round of betting starts with the player who opened the betting in the first round. A common variation is to start the betting with the player who last raised the bet in the opening round.

To change this setting, see Options - Rules.


Four-Card Hands

As a convenience, in the opening round of betting (before you discard), Smoke'em Poker checks your cards for the following four-card hands:

•	baby straight flushes - four-card straight flushes with no gaps

•	baby flushes - four-card flushes (gaps or not)

•	outside straights - four-card straights with no gaps (a.k.a. two-sided straights)

•	inside straights - four-card straights with a gap between two of the cards, or one-sided straights (ace-low or ace-high)

These hands, while worth nothing in themselves, only need one card to make them into excellent hands. Smoke'em Poker points out these promising hands for you, but only points them out before the discard (while you still have a chance to complete them).

When deciding how to label your hand before the discard, Smoke'em Poker follows these rules:

•	inside straights are better than runts

•	outside straights are better than pairs

•	baby flushes are better than outside straights

•	baby straight flushes are better than baby flushes

For example, suppose that you started with a hand of 3-4-4-5-6. Before you discarded anything, Smoke'em Poker would label your hand as an outside straight, since this is potentially worth more than your pair. If you had this same hand after the discard, however, the outside straight would no longer have a chance of becoming a real (five-card) straight, so Smoke'em Poker would label it as just a pair.


Setting Options

Smoke'em Poker remembers its settings between sessions, and saved games remember their own settings independently.

To change the game options for Smoke'em Poker, do one of the following:

•	click Set Options First in the welcome dialog

•	click Options in the main window

Either of these opens the Options dialog, which is divided into the following pages:

•	General (customizing the interface to suit you)

•	Card Backs (choosing a card-back design)

•	Rules (setting the house rules and stakes)

•	Opponents (configuring your simulated opponents)

The following controls are not associated with any particular page - they apply to the dialog as a whole.

Old Games:

Opens the old-games dialog, where you can manage your saved games.

OK:

Exits the Options dialog and saves your changes.

If you have changed any settings on the Rules or Opponents pages, Smoke'em Poker reminds you to start a new game using the new settings.

Cancel:

Exits the Options dialog without making any changes.

Help:

Opens on-line help for the Options dialog.

Note: If you play Smoke'em Poker from a read-only disk (such as a CD-ROM), it will not be able to save any changes that you make in the Options dialog. Your changes will last only until you quit Smoke'em Poker; when you restart the game, the options will revert back to their original settings. You can avoid this by installing Smoke'em Poker to your hard disk.


Options - General

The General page of the Options dialog lets you customize the interface to suit your preferences. You can change these settings at any point in a game, and they take effect immediately.

Your name:

Your name (up to 12 characters). If you don't enter a name, you're called "Stranger".
Defaults to "Stranger".

Sound effects:

Turns sound effects on or off.

Depending on the Allow in background option (see below), it is also muted when the game is not the active application (i.e. not frontmost).
Defaults to ON.

For more help, see Controlling Sound.

Allow in background:

Tells Smoke'em Poker to keep playing its sounds even when it's in the background (i.e. when you're using another application). You may find this useful for aurally keeping track of the game as it carries on in the background. This option is only available when Sound effects are turned on.
Defaults to OFF.

For more help, see Controlling Sound.

Playing speed:

The When you're in slider sets the speed of the action when you're involved in the current hand. Defaults to 4 (where 10 is fastest).

The When you're out slider sets the speed of the action when you're out of the hand or when you're watching (see Watching The Game). Defaults to 8 (where 10 is fastest).

Conveniences:

The Sort during deal option automatically sorts the hands as each card is dealt. If this setting is turned off, hands are not sorted until they are completely dealt. Defaults to OFF.

When discarding, the Pre-select your discards option tells Smoke'em Poker to examine your hand and automatically select the cards that it thinks you should discard. This feature is particularly convenient when used in conjunction with Key Shortcuts. Defaults to OFF.
Note: Smoke'em Poker always tries to fill outside straights and four-card flushes (or straight flushes) instead of keeping a pair, but keeps a pair instead of an inside straight.

The Fly-by help for controls option turns fly-by help (a.k.a. "hint text" or "tool tips") on or off. When it's on, pointing at a control will give you a short description of what it does. Defaults to ON.

The Save latest game as icon option automatically maintains an icon in Program Manager (or the Win95 desktop) for your most recently saved game. This is the quickest way to restart the game later. Defaults to ON.

Cheating:

The Reveal opponents' skill/style option reveals each opponent's skill level and betting style during the game. These are shown beside the player's name in short form (for example, "Dave (b/T)" means that Dave is a "bonehead" who plays "tight"). Defaults to OFF.
For more information on skill levels and betting styles, see Choosing Opponents.

The Reveal opponents' hands option shows the other players' hands face-up throughout each hand. Not that we'd ever use this feature...nope...not us... Defaults to OFF.


Options - Card Backs

The Card Backs page of the Options dialog lets you choose the design on the backs of the cards (i.e. when they are face-down). You can change this setting at any point in a game, and it takes effect immediately.

Choose a design by clicking it. The current design is popped up above the other card backs.


Options - Rules

The Rules page of the Options dialog lets you set the house rules and stakes for the next new game. These settings do not affect a game in progress - they are only applied to subsequent games, and are shown in bold.

Allow check-raising (sandbagging):

Permits check-raising (also known as sandbagging) in the game.
Defaults to ON.
Note: Call-raising (re-raising when you had previously called) is always allowed.

Redeal if no one opens:

If everyone checks in the opening round, they all ante again for a new deal. See House Rules.
Defaults to ON.

Allow four-card draw on ace:

Permits ace-high hands to draw four cards instead of three. See House Rules.
Defaults to ON.

Start final bets at:

Determines who opens the final round of betting. See House Rules.
Defaults to First bettor in opening round.

Starting cash:

The amount of money that every player starts with. Must be between $100 and $999999, and cannot be smaller than the ante.
Defaults to $1000.

Ante:

The amount of money that each player chips in to play in each hand. Must be between $1 and $999, and cannot be larger than the starting cash.
Defaults to $10.

Maximum # of raises:

The maximum number of raises (not including the first bet) that are allowed in each round of betting. Must be between 1 and 10. Defaults to 3.

Minimum Bet:

The smallest amount that a player can raise. Must be between $1 and $9999, but should be smaller than the medium bet (see below). Defaults to $10.

Medium Bet:

The in-between amount that a player can raise. Must be between $1 and $9999, but should be larger than the minimum bet and smaller than the maximum bet. Defaults to $25.

Maximum Bet:

The largest amount that a player can raise. Must be between $1 and $9999, but should be larger than the medium bet. Defaults to $50.

Reset To Defaults:

Resets all values on the Rules page to their "factory settings".


Options - Opponents

The Opponents page of the Options dialog lets you configure your simulated opponents in a new game. These settings do not affect a game in progress - they are only applied to subsequent games, and are shown in bold.

The settings for the computer players are arranged to match the seating arrangement around the poker table.

For each player, you can set the following:

In game:

Includes the player in the game. If you turn this setting off, the other controls for the player are automatically disabled.
Defaults to ON.

Name:

Name of the computer player. If you supply a name of your own, make sure that you set the Sex setting to agree with the name (so that Smoke'em Poker can play appropriate sounds for the player). If you leave the Name field blank, Smoke'em Poker supplies a random name each time you start a new game (the name will be male or female depending on the sex of the player).
Defaults to (random).

Skill:

Determines the skill of the computer player:

−	Bonehead - Can barely distinguish good hands from bad ones, but bets anyway (duh).

−	Fair - Bets based on the value of their own hand only.

−	Good - Bets based on the value of their own hand and the amount of betting so far in the round.

−	(random) - For each new game, this selects a random skill level (Bonehead, Fair, or Good). The random skill level is only revealed if you select the Reveal opponents' skill/style option on the General page.

Defaults to (random).

In upcoming releases of Smoke'em Poker, I hope to add more skill levels - see Future Enhancements.

Style:

Determines the betting style of the computer player:

−	Loose - This aggressive player bets often, typically in large amounts, and bluffs a fair bit.

−	Normal - This middle-of-the-road player bets reasonably, typically in moderate amounts, and bluffs once in a while.

−	Tight - This conservative player bets less often, typically in smaller amounts, and seldom bluffs.

−	 (random) - For each new game, this selects a random betting style (Loose, Normal, or Tight). The random style is only revealed if you select the Reveal opponents' skill/style option on the General page.

Defaults to (random).

Sex:

Determines the sex (male or female) of the player. This helps Smoke'em Poker supply appropriate names for unnamed players, and to use appropriate sounds for some events.
Defaults to (random).

Set Random:

To quickly change every opponent's settings to random values, click Set Random.

This pops up a menu that lets you set the names, skills, styles, sex (or all of these at once) to random values.


Starting A New Game

To end the current poker game and start a new poker game (with fresh stakes), click New Game. You are prompted to save the current game (if any).

A new game resets each player's cash to the starting cash amount, and resets the game statistics.


Playing A Hand

Here's how you go about playing a hand in Smoke'em Poker.

Paying the Ante and Dealing:

To deal a new hand, click Deal. After the cards are shuffled, each player automatically pays the ante for the hand, and the cards are dealt. The dealer is outlined in purple while dealing, and the dealer's name is highlighted in purple throughout the hand.

Note: Even if a player's cards are shown face-up on the screen (using the Reveal opponents' hands option), players never see each other's cards until the hand is over.

Opening Bets:

When the betting comes around to you, you can do one of the following:

−	Check (or pass) your bet if no one else has bet yet. Check does not appear if someone has made a bet before you.

−	Fold your hand to get out of the current hand without matching the current bet. Fold does not appear if no one has made a bet yet.

−	Call the current bet by paying enough to match it. Call does not appear if no one has made a bet yet.

−	Bet (open the betting) or Raise the current bet by matching it and then increasing it by a certain amount.
To bet or raise, click Bet/Raise and choose from one of the three fixed amounts in the raise window. These amounts are determined by the stakes that you set for the game.
Bet/Raise does not appear if the maximum number of raises has already been reached, or if this would be a check-raise in a game where you have prohibited check-raising.

Discarding Cards:

To discard up to three cards from your hand, click the unwanted cards to select them, then click Discard. Replacement cards are dealt from the deck and automatically sorted into your hand.

To stand pat (that is, to keep all of your cards), make sure that no cards are selected, then click Discard None.

Note: You can allow four-card discards for ace-high hands - see Options - Rules.

Closing Bets:

Betting in the closing round is done exactly as it is in the opening round. Betting starts with either the opener or last raiser from the opening round - see Options - Rules.

The Showdown:

After the closing bets are done, the remaining players reveal their hands, starting with the player who made the final raise. The winner of the hand is outlined in gold (the color of money) and collects the cash in the pot.

At this point, if a simulated player is out of money, they leave the game. If you are the last player left, you win the game. If you run out of money, you lose.


Key Shortcuts

Most buttons have a keyboard shortcut (a key that you can press instead of using the mouse to click the button). For a given button, the key shortcut is the underlined letter (for example, Q for Quit).

For the speaker button in the main window, the shortcut is S.

In the Bet/Raise pop-up menu, you can choose a bet by pressing the up or down arrow keys, or you can cancel the raise by pressing Esc.

When discarding, you can press 1, 2, 3, 4, or 5 to select the corresponding card.

In addition, you can use the Enter key to activate the default button. The default button changes depending on the stage of the hand, as follows:

•	After a hand, Deal is the default button.

•	If there is no bet yet, Check is the default button.

•	If there is a bet, Call is the default button.

•	If some discards are selected, Discard is the default button.

•	If you shouldn't discard any, Discard None is the default button (for example, if you have a pat flush).

These "smart" shortcuts let you play a hand mostly by pressing Enter. (Can you say "couch potato"?)

You'll probably find that using key shortcuts (especially the "smart" Enter key) is faster and easier than continually mousing around and clicking buttons, especially once you play a few games.

Most dialogs and windows can be closed by pressing Esc.


Examining The Odds

To examine poker odds for the current hand, click Odds.

This opens the Odds window. You can leave this window open throughout the game.

The Current hand combo box shows all possible types of poker hands, including four-card hands. If you're playing in the current hand, this field automatically shows the type of hand that you were dealt. At any time, you can choose a different type of hand to examine.

The table shows a list of final (five-card) hands. For each of these hands, the table shows:

•	the odds against improving your hand to exactly that type of hand (where possible)

•	the odds against improving your hand to a hand at least that good (where possible)

•	the approximate chance of winning with that type of hand (based on thousands of test hands run in Smoke'em Poker)

Note: For simplicity, the odds have been rounded to the nearest half (e.g. 4.2 becomes 4)

The Current payback (pot odds) field shows the simple odds currently offered by the pot. This is calculated as the total pot divided by what you currently owe. No pot odds are shown if you don't owe any money, or if you're out of the hand.

In poker, a good rule of thumb is to fold when the pot odds are less than the odds against improving your hand to something that you think will win. For example, the odds against improving a four-card flush to a full flush are about 4:1, so you may not want to bet on that four-card flush unless the pot is offering at least a 4:1 payback.


Generating Statistics

For each poker game that you play, Smoke'em Poker keeps track of various statistics that can help you analyze your play (and your opponents' play).

The number of hands played so far is shown in the title bar of the main window, and also in the icon's caption (if the game is minimized).

To examine detailed statistics for the current game, click Stats.

This opens a statistics window. You can leave this window open throughout the game.

The statistics window contains several tabbed pages. Click a tab to display the corresponding page.

Clicking the Graph Of Winnings tab displays a line graph of each player's cash over the last 100 hands. The graph automatically scales itself to show the highs and lows for each player over the graphed interval. If a player went broke before the graphed interval, they are excluded from the graph.

The statistics window is automatically updated after each hand.

Statistics can be very useful in computer poker, since you can play many more hands in a given time that you would in normal poker. This can reveal basic weaknesses in your play (for example, you may find that you are in too many showdowns - a losing habit in the long run).


Controlling Sound

Smoke'em Poker offers several ways to control sound effects during a game. These effects include shuffling, dealing, coins clinking, and so on.

You can turn sound on and off in the General page of the Options dialog, or by using the speaker button at the lower left of the main window.

Sound is automatically muted when Smoke'em Poker is minimized. Depending on the Allow in background option in the Options dialog, it is also muted when the game is not the active application (that is, when it is not frontmost).

Sound is automatically disabled if either of the following is true:

•	You didn't install the Smoke'em Poker sounds (that is, you don't have a sounds folder).
To get sound, you must install the sounds using the installation program (SETUP.EXE).

•	You don't have a WAV sound driver installed for Windows.
To get sound, you must install a suitable driver. Check with your local dealer or the sound-card maker.

Note: Sounds take time to play. If you want the fastest game possible, turn the sound off.

You can also customize the sounds  that Smoke'em Poker uses.


Customizing Sounds

Smoke'em Poker can play sound effects for most events in a game. This section explains how Smoke'em Poker handles sounds, and how you can customize these sounds.

The Smoke'em Poker sounds are stored as WAV files in the SOUNDS folder where you installed Smoke'em Poker (e.g. C:\SEPKR19\SOUNDS). The sound files are organized in subfolders that correspond to the various game events. Each subfolder can contain many sounds, one of which is chosen randomly when Smoke'em Poker needs a sound for that event.

The folders correspond to game events as follows:

BeerWare	Clicking About

CloseSd	Close showdown (where two pair or less is narrowly beaten)

GoodHand	Three of a kind or better

GreatHan	Full House or better

HeGone	Male player leaves the game

HeSteal	Male player wins an uncontested pot

LoadSave	Loading or saving a game

LoseGame	You lose the game

MaxBet	Many coins clinking

MedBet	Some coins clinking

MinBet	One coin clicking

NoDitch	You try to discard more than three cards

Quit	You quit the game

Redeal	Everyone checks, and the hand is redealt

SheGone	Female player leaves the game

SheSteal	Female player wins an uncontested pot

Shuffle	Shuffling the deck before each hand

Smoke	Close showdown (where 3/kind or more is beaten)

SoundOn	Turning sound on using the "speaker" button

Tied	Tied hands (splitting the pot)

Wait	After waiting 15 seconds for you to continue play

WinGame	You win the game

WinHand	You win the current hand

The only sound event not represented by a folder is the deal-card event. For the sake of speed and simplicity, it's hardwired to the DEALCARD.WAV sound in the SOUNDS folder. You can replace this sound if you really want to, but make sure that your replacement is called DEALCARD.WAV.

As an example, if a player wins with a great hand (say, four of a kind), Smoke'em Poker will play a random sound from the SOUNDS\GREATHAN folder. If there are no sounds in a given folder, no sound will be played. If the subfolder doesn't exist, the program will complain and carry on.

This scheme lets you customize which sounds get played for which events, and lets you add your own WAV sound files as you wish. The sound files themselves can have any name, as long as it is no longer than 8 characters with a .WAV extension (no Win95 long filenames, please).

In a future release, I'd like to have sound folders for named players - see Future Enhancements.


Getting Help

To get on-line help at any time during the game, click Help or press F1.

If you ask for help while in a particular dialog (such as the Options dialog), the help window opens to the appropriate topic (e.g. how to generate statistics). Otherwise, the table of contents is displayed. You can also Search the index for the topic you want.

Once you've found what you need in the on-line help, you can either close the help window or switch back to Smoke'em Poker without closing it.

Of course, you can also open the help file (SEPOKER.HLP) directly from the Program Manager, File Manager, Win95 Start menu, Explorer, or whatever.


Running Out Of Money

A player can keep playing until they run out of money. More precisely, a player can play a hand if they can afford the ante. They are allowed to go into debt (showing negative cash) while betting on a hand.

When one of your simulated opponents doesn't have enough money left to ante up for the next hand, they leave the table, and their name is dimmed. If you bankrupt all of your opponents, the game ends with you as the new poker champion (woohoo!).

If you run out of money, you can do one of the following:

•	Start a new poker game (everyone gets a fresh bankroll), or

•	Crawl into a hole and die (quit, that is), or

•	If there are at least two other players left, you can let them continue the game without you.


Watching The Game

Instead of playing in every hand, you can sit out for a while and watch the other players go at it.

To watch the game, click Watch. The other players continue the game without you until you interrupt them or until one of them wins the game.

To interrupt a game that you're watching, click Stop Watching. Once the players finish the current hand, you can rejoin the game.

You can also watch a game if you lose all of your money and there are at least two other players left. In the "losing" dialog that appears, select the Let other players continue game option. When you exit from the dialog, the remaining players continue the game as described above.

Note that you can't start watching the game in the middle of a hand - Watch is only available between hands.

While watching a game, you can switch to another application and Smoke'em Poker will carry on in the background. Note that if a watched game is minimized (reduced to an icon), it will run extremely fast (since it doesn't have to spend time drawing graphics).


Saving Unfinished Games

If you don't have time to finish a game in one sitting, you can save the unfinished game and resume it later.

To save a game, you must have played at least one complete hand.

Smoke'em Poker will prompt you to save an unfinished game when:

•	starting a new game

•	resuming a different saved game

•	quitting the program

If you agree to save the game, it is automatically saved in its own file in the OldGames folder of your Smoke'em Poker folder. All settings, window positions, statistics (and so on) are saved along with the game.

Note: You should finish the current hand before saving a game, since Smoke'em Poker does not save the state of a hand-in-progress (everyone just loses the money they've bet so far on the hand).

You can save any number of games.

If you resume a saved game, play more hands, then save it again, it automatically overwrites the old information in the same game file.

If you resume a saved game, play more hands, then don't save it, Smoke'em Poker gives you the option of keeping the previous version of the game or just deleting the saved game altogether.

Note: If you play Smoke'em Poker from a read-only disk (such as a CD-ROM), you will not be able to save games. You can avoid this by installing Smoke'em Poker to your hard disk.


Resuming Saved Games

The easiest way to resume your most recent game is to double-click the Last Game Played icon in the Smoke'em Poker window in Program Manager (or Explorer or the Windows 95 desktop). This automatically starts Smoke'em Poker and resumes the game.
Unless you decide otherwise (see Options - General), Smoke'em Poker keeps this icon up to date, so that it always represents your most recently saved game (if any).

To resume any saved game (not just the most recent one), you can do one of the following:

•	start Smoke'em Poker and click Resume an Old Game in the welcome dialog

•	at any time, open the Options dialog, then click Old Games

Either of these opens the old-games dialog, which shows a complete list of saved games. The most recent games are listed first.

•	Select a game to show more information about it.

•	To resume a game, select it and click Resume.

•	To delete a game altogether, select it and click Delete.
(Pressing the Ctrl key at the same time bypasses the confirmation dialog.)

If you don't mind dealing with cryptic filenames, you can even resume a saved game by:

•	double-clicking the saved-game file in File Manager (or Explorer), or dropping it onto the Smoke'em Poker main window

•	from a DOS prompt, typing sepoker.exe <filename>  where <filename> is the name of the saved-game file in the OldGames folder

Saved games are automatically deleted when they are finished (won by a single player).


Quitting The Program

To quit Smoke'em Poker at any time, click Quit or choose Close from the window menu. You are prompted to save the current game (if any).

If you try to quit while watching a hand finish, the hand will finish as quickly as possible, then the program will close.


Uninstalling The Program

If you ever want to remove Smoke'em Poker from your system, double-click Uninstall Smoke'em Poker in the Program Manager (or in the Windows 95 Start menu). This will let you remove some or all of the files that were copied to your hard disk during the installation process.

Note: The uninstaller only remembers the files that you most recently installed for Smoke'em Poker. The only time when this is a problem is if you install Smoke'em Poker without the sounds, then install the sounds later. When you try to uninstall, the uninstaller will only remember the details of the latest installation (the sounds).

In any case, Smoke'em Poker is a fairly tidy application - it keeps all the files it needs in its own folder. If you want to remove Smoke'em Poker manually, just delete its folder and the Smoke'em Poker program group.


Sending Bug Reports, Suggestions, etc.

If you find any bugs or problems in Smoke'em Poker, or if you have suggestions for future releases, I'd like to hear from you. You can reach me at:

•	E-mail: 	dobrien@watcom.com

•	Web:	http://www.cgl.uwaterloo.ca/~gmgrimsh/dobrien.html

•	Snail-mail: 	Dave O'Brien
48 Northmanor Crescent
Kitchener, Ontario
Canada, N2N 3C2

It helps me if you include the following information:

•	your version of Smoke'em Poker

•	where you got Smoke'em Poker from (it's neat to see where it gets to)

•	what kind of PC you're using (e.g. 486, Windows 3.1, 8 megs RAM)

•	what you most like and dislike about the program

•	what feature you want added next

•	anything else that occurs to you

•	your favorite beer (after all, it's BeerWare!)

This also lets me give you advance notice (by e-mail) when I release new versions of Smoke'em Poker.


Known Problems

The following are bugs and problems that I know of:

•	On some machines running the Windows NT 4.0 beta (and maybe Windows 95), Smoke'em Poker crashes (or doesn't start) when you first try to run it, but it works fine if you try to run it again. I have no clue why this happens.

•	Smoke'em Poker does not handle the case of three or more players tying (having the same hand) in the showdown (e.g. three Ace-high flushes). If this ever happens (which is extremely unlikely), only two of the players will split the pot.

•	When comparing very close hands at the showdown, Smoke'em Poker only looks to the third (and sometimes fourth) card to break any ties. While this may result in the wrong player winning the pot, it is so unlikely that I've left it that way for now.

•	In Windows 95 on a small screen (640x480), the bottom of the main window may be initially obscured by the system taskbar. Just move the window up manually. Since Smoke'em Poker remembers your window positions between sessions, you only have to do this once.
On small screens using large fonts, you may have to make more room by pulling the top of the taskbar down to reveal the bottom of the window. (Remember to pull it back up when you quit Smoke'em Poker.)
The Odds and Stats windows appear on the taskbar as separate tasks. Sorry for the clutter, but I don't know how to hide them from the taskbar.
Those mini-titlebars on the Odds and Stats windows don't pick up the new Win95 look.

•	If, for some reason, you install only the sounds during the installation, the installer creates a program group and icons anyway. Just delete them.

•	If you try to save a game in the middle of a hand, every player loses the cash they've bet so far in the hand, the game doesn't count in the stats, and the rest of the hand (if it's played out after the save) is ignored.
If, after losing money on a partial hand, there aren't enough players to ante for the next hand, the game isn't saved at all (this is an extremely rare case).

If you find any problems not listed here, please let me know - see Sending Bug Reports, Suggestions, etc..


Future Enhancements

Here's what I'd like to add to future versions of Smoke'em Poker (in no particular order):

•	More poker variations, of course, starting with the more common games like five-card stud, seven-card stud, hold'em, high/low splits, and so on. This would also open the door for dealer's choice. I'm not a big fan of wild-card games, so don't hold your breath for "pregnant threes"...

•	Network support (and maybe modem and Internet support), so that you could play a game with a mixture of human opponents and computer opponents.

•	More skill levels for the computer players. Also, computer players that learn about your betting tendencies and adjust their play accordingly. Eventually, I'd like to open up Smoke'em Poker to external modules that play via DDE (or whatever). This would allow you to code your own computer players and hook them into the game.

•	An Ask button that shows you what the various levels of computer players would do if they were in your position. Useful if you're just learning.

•	Better graphics and animation - a graphic pot that grows as more money is bet, animated dealing and discarding, player graphics (with an option to supply your own), and so on.

•	An option for sounds for each player, with sets of sounds that are tied to player names. You could record your buddies' voices and make Smoke'em Poker feel more like your local poker game.

•	Voice control using sound input from a SoundBlaster microphone. This shouldn't be too difficult given the limited vocabulary required. Couch potatoes needn't even lift a finger...

Any other enhancements or changes that you'd like to see? Let me know - see Sending Bug Reports, Suggestions, etc..


Acknowledgments

Here's the section where I admit who I've ripped off for ideas  ;^)

Namely:

•	Poker Pete on my old TRS-80. When you beat Pete out of all his money, he got up, pulled out his six-gun, and plugged you. Now there's a way to end a computer game!

•	Vegas Johnny Draw Poker by Top Score Software on MS-DOS. Pretty it ain't, but the features are there, the keyboard interface is fluid, and the play is easy to follow.

•	The players in my local Saturday-night game (Gina, Paul, Rob, Karen, Lou, Derek, Gord, et al.) who play-tested Smoke'em Poker, and without whom it would have taken half the time to program.  ;^D
Thanks to Rob, especially, for losing some huge real-life pots and thereby providing me with a name for my program ("What a smoke! What an incredible burn!"). Sorry that I couldn't include an animation of the famed Dance-Of-The-Unbelievably-Smoked in this release.

•	Thanks to Borland for Delphi, an very cool development system that made it easy for a C-hater like me to produce real Windows programs.

•	Special thanks to the Delphi developers whose components I used in this program, namely:

−	TCards by Indigo Software (for displaying real playing cards) - thanks, Zane!

−	Enhanced Control Kit by Richard Hansen (fancy buttons and labels)

−	SciGraph by Pierre Mertz (for the statistics graphing)

−	TProfile by Kenn Nesbitt (for managing INI files)

−	CCPanel by C.I.U.P.K.C. Software (source code used for the colored bevels)

−	SuperGrid by Pablo Pissanetzky (for the stats and odds tables)

−	NeatoMeter by Tim Noonan (for the load/save progress bar)

•	Special thanks also to TipTec Development for Freeman Installer, a flexible and easy-to-use program for making professional-quality installations.


Version History

You can always find the latest version of Smoke'em Poker at my Web page.

1.9 - June 19, 1996

•	added ability to save and load games

•	added options for:

−	redealing if no one opens

−	four-card draw on ace-high hands (thanks to Phil Geary)

−	starting final bets with opener or last raiser

•	revised the Options dialog (added Cancel button, etc.)

•	added welcome dialogs instead of dumping you right into a game

•	changed key shortcuts to allow (mostly) one-handed play (thanks to Bob Copps)

•	added new sound folders for redealing and loading/saving games

•	improved sound handling, and fixed some long-standing sound bugs (thanks to Steve Hohman and Tracy Yott)

•	changed X-discard cursor to arrow with X on bottom

•	added ability to restart game automatically after changing Rules/Opponents

•	improved face-up dealing and auto-sorting of opponent's hands

•	changed title bar for Odds & Stats to mini "floater" style

•	added Help command to system menu of Odds and Stats windows

•	added odds of improving 4-card hands to pair

•	fixed the nasty "black-card" bug that some users encountered (thanks to Mark Puckett, Cindy Davidson, and Buddy Akins)

•	fixed Sound pushbutton (speaker image appeared too far left)

•	minimized Stats and Odds windows now restore to full size when their buttons are clicked

1.8 - April 22, 1996

•	added configurable betting styles for the simulated players

•	added more card-back designs

•	spruced up the Options dialog and About dialog

•	changed the Pre-select your discards option to default to OFF, since new players were sometimes confused by it

•	improved the logic for playing sounds for close showdowns, big smokes, and uncontested pots

•	added fly-by help to the player's cards (when discarding) and to the Odds combo box

•	added some error-checking for playing from read-only disks (such as CD-ROMs)

•	added Help button to error dialogs

•	renamed some sound files

•	updated installer to remove unused files left over from previous versions

•	fixed bug where a bankrupt player's name wasn't drawn properly if they became the first dealer in the next game

•	fixed bug where, if you started a new game in the middle of discarding, the cards were left in their active-discard state

•	fixed bug where changing the Reveal Opponents' Cards option before the opening bets could cause a fatal error

1.7 - March 6, 1996

•	added a toggle-sound button in main window for convenience, and added a corresponding SoundOn sound folder

•	added an Odds window for showing odds of improving hand, pot odds, winning % of hand

•	statistics window

−	changed modal dialog into a modeless window that you can leave open (auto-updated after each hand, can be minimized to icon)

−	changed graph to simpler, faster format that can show 100 hands at once

−	merged player stats into one page

−	stats are visibly reset before the first hand of each new game

−	stats are blank for inactive players

−	graph legend is updated immediately after changing Reveal Skill setting in Options dialog

•	window layout (visibility and position) is saved between sessions (in SEPOKER.INI)

•	fixed bug where cards were re-drawn whenever a player's panel border changed (especially annoying on slower systems)

•	fixed bug where spin-edit controls in Options dialog didn't allow Enter to exit dialog

•	fixed bug where dialog images had hard-coded gray backgrounds

•	installs to C:\SEPKR17 (by default) so you can easily keep your old versions around if you want to

1.6 - January 25, 1996

•	added real card graphics with selectable card-backs, graphic shuffling

•	better sound handling, including random sounds for each game event

•	added a standard installer (SETUP.EXE)

•	changed auto-play mode to let you rejoin when only one computer player is left

•	added hand # to window title and icon caption

•	changed tabbed dialogs (Options, Stats) to remember your page

•	moved SEPOKER.INI to game directory

•	changed some cosmetics (buttons, labels, cursors, etc.), and shortened window to fit on small Win95 screens (above taskbar)

•	removed "graphics" and "help" subfolders (no longer needed)

•	fixed bug where initial bet was counted as a raise (i.e. if max # of raises was 3, you could only raise twice after the initial bet)

•	fixed bug where changing Stakes or Opponents (and restarting when prompted) while watching a game confused the program

•	fixed bug where ace-low straights evaluated as runts after discard

•	fixed bug where action text showed "Raised" instead of "Bet" for first bet in a round

•	fixed bug where turning all cards face-up after a hand caused an error

•	fixed bugs where stats graph didn't filter out players who went broke before graphed interval, didn't show starting cash, and used too much padding above and below graph lines

•	fixed several sound bugs

•	fixed bug where Restart and Watch buttons were not set correctly when you lost and had the option to let the others continue the game

•	fixed bug where selecting Sort-during-deal option during deal could leave your hand unsorted and incorrectly evaluated

•	fixed bug where busy cursor wasn't shown at proper times

•	fixed bug where some controls didn't have flyby-help text

1.5 - November 20, 1995

•	initial Windows release (earlier versions available for Amiga)


About BeerWare

Smoke'em Poker is BeerWare: if you like it, have a beer!

BeerWare is free, so keep it, play it, and make copies for your friends.

 (A long time ago, in an interview far, far away, a game programmer said that he and his rivals were competing for the user's beer money. Hence the happy concept of BeerWare - you can play this game and still afford beer.)

If you want to redistribute this software, see Redistribution (Legal Stuff).

More BeerWare* coming soon (?):

•	Battle Grid - two players pit their knights, assassins, clerics, and sorcerers against each other on a 8x8 grid

•	Net Runner  - expand and conquer a computer network using viruses, trojan horses, and worms to punch through your opponents' I.C.E.

* Strictly speaking, these titles are currently BelchWare (vapor), but they may condense soon.

By the way, this documentation is also BeerWare: if you've read this far, have another one!


About The Author

I'm a technical writer by trade (paid by the word - can you tell?), and I program on the side for fun.

I dabbled in Amiga programming before I moved to Windows (i.e. sold out), but I got lucky and found a great Windows development system - Borland Delphi.

My two other favorite diversions are playing poker and riding recumbent bikes (not at the same time).

To contact me, see Sending Bug Reports, Suggestions, etc..


About Borland Delphi

This program was ported from CanDo on the Amiga ("it's not dead, it just smells funny") to Borland Delphi on Windows.

Delphi is a very cool, very fast, mostly mellow development system for Windows. It's like Visual Basic, but uses compiled Object Pascal instead. I highly recommend it for those who want to develop fast Windows apps without messing with C, C++, MFC, and all that gunk.

To the Delphites at Borland - thanks much!


Redistribution (Legal Stuff)

While this software is free, it is not public domain, meaning that:

•	I retain the copyright (©1995-96 by Dave O'Brien. All rights reserved. So there.)

•	If you copy this software to other sites or for other people, you shouldn't change the contents of the distribution archive, and you shouldn't charge any money for it (except for nominal disk-copying fees).
If you discover bugs, think up improvements, or otherwise want to change the distribution contents, let me know and I'll try to oblige you - see Sending Bug Reports, Suggestions, etc..

•	You can include this program in a commercial CD-ROM compilation as long as you meet the following conditions:

−	The marginal cost of my program (CD price divided by total # of programs) must be no more than typical disk-copying fees (that is, a few dollars)

−	You let me know beforehand (e-mail is easiest)

−	You send me a copy of the CD-ROM at my home address

−	You honor the BeerWare agreement by having a beer!


No Windows sound driver

Your system doesn't seem to have any sound equipment capable of playing the sounds included with Smoke'em Poker. In technical terms, your system doesn't seem to have a Windows sound driver installed that can handle WAV sounds.

The most common cause of this is that you don't have a sound card in your PC. The basic PC speaker itself doesn't count as a sound card.

You can still play Smoke'em Poker, but all sound effects have been turned off. The sound controls will remain disabled until you fix your Windows sound setup.

To get sound, you must install a sound card and the Windows driver software for it. For more help with sound drivers, ask your local dealer, the sound-card manufacturer, or the nearest computer geek.


"Sounds" folder not found

Smoke'em Poker couldn't find a SOUNDS folder in the folder where you installed it. This is where Smoke'em Poker looks for game-related sounds.

For example, if you installed Smoke'em Poker to C:\SEPKR19, it will expect to find sounds in C:\SEPKR19\SOUNDS, as shown in the following tree:

C:\SEPKR19

SOUNDS

BEERWARE

BEERBURP.WAV

MMMMBEER.WAV

CLOSESD

(etc.)

(Upper- and lowercase do not matter for naming folders or sound files.)

You can still play Smoke'em Poker, but all sound effects have been turned off. The sound controls will remain disabled until Smoke'em Poker finds a SOUNDS folder in its own folder.

The easiest way to fix this problem is to install Smoke'em Poker again using the installation program (SETUP.EXE) that came with it.


Unrecoverable error in Smoke'em Poker

Smoke'em Poker has stumbled across a serious error in its own programming, and cannot continue the game.

Smoke'em Poker will now quit and return in shame to its own folder, where it will curse and sulk and refuse to cooperate when you try to reproduce this error again (so that you can report it to the program's author).